import "./styles.css";
import anime from "animejs";
import { Howl, Howler } from "howler";

// rotating earth

// She got the whole wide world
// Singing baby's song

const sekce = {
  DET: "Digitalizace, e-government, transparence", //
  SOC: "Sociální tematika", //
  SKO: "Školství, vzdělávání", //
  ZP: "Životní prostředí, příroda", //
  ZDR: "Zdravotnictví", //
  FIN: "Finance, rozpočtová tematika" //
};

const progItems = {
  "prace-a-socialni-veci": {
    rot: -2,
    corr: 1,
    file: "ik_prace_a_socialni_veci_svgo.svg",
    title: "Sociální politika"
  },
  doprava: {
    rot: -38,
    corr: 0.98,
    file: "ik_doprava_svgo.svg",
    title: "Lepší dopravní obslužnost"
  },
  nebezpeci: {
    rot: -53.5,
    corr: 1,
    file: "ik_nebezpeci_2_svgo.svg",
    title: "Nebezpečí a krize"
  },
  ekologie: {
    rot: -101.5,
    corr: 1,
    file: "ik_ekologie_svgo.svg",
    title: "Péče o životní prostředí začíná tam, kde žijeme"
  },
  energetika: {
    rot: -177,
    corr: 1.02,
    file: "ik_energetika_svgo.svg",
    title: "Pokroková a udržitelná energetika"
  },
  prumysl: {
    rot: -195,
    corr: 1.04,
    file: "ik_prumysl_svgo.svg",
    title: "Průmysl připravený na změny"
  },
  skolstvi: {
    rot: -212,
    corr: 1.02,
    file: "ik_skolstvi_svgo.svg",
    title: "Kvalitní školství a vzdělávání"
  },
  zemedelstvi: {
    rot: -228,
    corr: 1,
    file: "ik_zemedelstvi_svgo.svg",
    title: "Zemědělství"
  },
  sport: {
    rot: -250,
    corr: 1,
    file: "ik_sport_svgo.svg",
    title: "Podpora sportu a zdravého životního stylu"
  },
  transparence: {
    rot: -267,
    corr: 1.04,
    file: "ik_transparence_svgo.svg",
    title: "Otevřená a moderní radnice"
  },
  bydleni: {
    rot: -286.5,
    corr: 1,
    file: "ik_bydleni_svgo.svg",
    title: "Dostupné a důstojné bydlení pro kvalitní život"
  },
  zdravotnictvi: {
    rot: -323.7,
    corr: 1,
    file: "ik_zdravotnictvi_svgo.svg",
    title: "Dostupná a kvalitní zdravotní péče"
  },
  ekonomika: {
    rot: -23,
    corr: 0.98,
    file: "ik_ekonomika_svgo.svg",
    title: "Moderní ekonomika"
  }
};

// get window size

var width =
  window.innerWidth ||
  document.documentElement.clientWidth ||
  document.body.clientWidth;

var height =
  window.innerHeight ||
  document.documentElement.clientHeight ||
  document.body.clientHeight;

console.log("Width:" + width + " Height:" + height);

// calculations
// let's do some geometrics math

let uhel = 52; // uhel viewportu
let focus = 28; // zamereni viewportu na vysku
const defsize = 119.84;

function degrad(degrees) {
  var pi = Math.PI;
  return degrees * (pi / 180);
}

let uhel2 = Math.round((180 - uhel) / 2);
let polomer = Math.round(width / (2 * Math.cos(degrad(uhel2))));
let vyska_c = Math.round(polomer * Math.sin(degrad(uhel2)));
let vyska = Math.round(polomer - vyska_c);

let posun_x = Math.round((2 * polomer - width) / 2);

let p1 = Math.round(polomer * focus * 0.01);
let posun_y = Math.round(height / 2 - p1);

let resize_factor = (2 * polomer) / defsize;
//console.log ('Puvodni rozmery:'+JSON.stringify(vb));
//console.log ('Puvodni sirka:'+puv_x+', Puvodni vyska:'+puv_y);

console.log(
  "Polomer:" +
    polomer +
    ", Vyska kruhu:" +
    vyska +
    ", PosunX:" +
    posun_x +
    ", PosunY:" +
    posun_y
);
console.log("Resize factor: " + resize_factor);

// position of whole
var shape = document.getElementById("whole");
//shape.style.left='-'+posun_x+'px';
//shape.style.top=posun_y+'px';
//shape.style.width=Math.round(polomer*2)+'px';
shape.style.height = Math.round(2 * (polomer + posun_y)) + "px";
shape.style.width = Math.round(width) + "px";

// position of earth
shape = document.getElementById("zemegula");
shape.style.left = "-" + posun_x + "px";
shape.style.top = posun_y + "px";
shape.style.width = Math.round(polomer * 2) + "px";

// position of obloha
shape = document.getElementById("obloha");
shape.style.left = "-" + posun_x + "px";
shape.style.top = posun_y + "px";
shape.style.width = Math.round(polomer * 2) + "px";

// position of circle
shape = document.getElementById("circlepath");
shape.setAttribute(
  "viewBox",
  "0 0 " + Math.round(polomer * 2) + " " + Math.round(polomer * 2)
);
shape.style.width = Math.round(polomer * 2) + "px";
var svgns = "http://www.w3.org/2000/svg";

var circle = document.createElementNS(svgns, "circle");
circle.setAttributeNS(null, "cx", polomer - posun_x);
circle.setAttributeNS(null, "cy", polomer + posun_y);
circle.setAttributeNS(null, "r", polomer * 0.656);
circle.setAttributeNS(
  null,
  "style",
  "fill: none; stroke: #ff0000; stroke-width: 1;"
);
shape.appendChild(circle);

//shape = document.getElementById("path");
//shape.style.width=Math.round(polomer*2)+'px';

// start the groove

var oanimation = anime({
  targets: "#obloha",
  rotate: 360,
  duration: 240000,
  loop: true,
  easing: "linear"
});

var path = anime.path("#circlepath circle");

var babish = anime({
  targets: ".loop",
  translateX: path("x"),
  translateY: path("y"),
  rotate: path("angle"),
  easing: "linear",
  direction: "reverse",
  duration: 60000,
  loop: true
});

// start the noise

var soundon = 1; // muting

var sound = new Howl({
  src: ["./src/assets/babis.webm", "./src/assets/babis.mp3"],
  loop: true
});

sound.volume(0);
sound.play();

// events and moving of acter

var smer = "right";
var mer = 0.75;
var deg = 0;
var step = 2;
var limit = false;
var limit2 = false;
var quantum = 500;

const myInterval = setInterval(myTimer, 200);

function myTimer() {
  const date = new Date();
  var burangle = Math.round(
    360 - getRotationAngle(document.getElementById("bureshkara"))
  );
  var prepangle = deg % 360;
  if (prepangle < 0) prepangle += 360;
  var uv = Math.abs(prepangle - burangle);
  if (uv > 180) uv = 360 - uv;
  var hlasitost = 0;
  if (uv < 40) hlasitost = 0.05 + 0.015 * (40 - uv);
  if (uv < 30) hlasitost = 0.2 + 0.03 * (30 - uv);
  if (hlasitost > 1) hlasitost = 1;
  hlasitost = soundon * hlasitost;
  sound.volume(hlasitost);
  document.getElementById("debug").innerHTML =
    date.toLocaleTimeString() +
    ", A:" +
    deg +
    "° (" +
    prepangle +
    "°), B:" +
    burangle +
    "°, UV:" +
    uv +
    "°";
}

myTimer();

function setlimit(cas) {
  setTimeout(() => {
    limit = false;
    //console.log('Limit off');
  }, cas);
}

function setlimit2(cas) {
  setTimeout(() => {
    limit2 = false;
    //console.log('Limit off');
  }, cas);
}

function getRotationAngle(target) {
  const obj = window.getComputedStyle(target, null);
  const matrix =
    obj.getPropertyValue("-webkit-transform") ||
    obj.getPropertyValue("-moz-transform") ||
    obj.getPropertyValue("-ms-transform") ||
    obj.getPropertyValue("-o-transform") ||
    obj.getPropertyValue("transform");
  let angle = 0;

  if (matrix !== "none") {
    const values = matrix.split("(")[1].split(")")[0].split(",");
    const a = values[0];
    const b = values[1];
    angle = Math.round(Math.atan2(b, a) * (180 / Math.PI));
  }

  return angle < 0 ? (angle += 360) : angle;
}

function move_right() {
  if (smer == "left") {
    var animation = anime({
      targets: "#biker",
      rotateY: 0,
      duration: 120,
      easing: "easeInOutSine"
    });
    smer = "right";
  }
  if (limit == false) {
    deg -= step;
    limit = true;
    setlimit(quantum);
    console.log("left arrow -" + deg);

    var animation = anime({
      targets: "#whole",
      rotate: deg,
      duration: quantum,
      loop: false,
      easing: "linear"
    });
  } else if (limit2 == false) {
    deg -= step * 2;
    limit2 = true;
    setlimit2(quantum * 1.2);
    console.log("left arrow - " + deg);
    var animation = anime({
      targets: "#whole",
      rotate: deg,
      duration: quantum,
      loop: false,
      easing: "linear"
    });
  }
}

function move_left() {
  if (smer == "right") {
    var animation = anime({
      targets: "#biker",
      rotateY: 180,
      duration: 120,
      easing: "easeInOutSine"
    });
    smer = "left";
  }
  if (limit == false) {
    deg += step;
    limit = true;
    setlimit(quantum);
    console.log("right arrow - " + deg);
    var animation = anime({
      targets: "#whole",
      rotate: deg,
      duration: quantum,
      loop: false,
      easing: "linear"
    });
  } else if (limit2 == false) {
    deg += step * 2;
    limit2 = true;
    setlimit2(quantum * 1.2);
    console.log("right arrow - " + deg);
    var animation = anime({
      targets: "#whole",
      rotate: deg,
      duration: quantum,
      loop: false,
      easing: "linear"
    });
  }
}

document.querySelector("#button_left").onclick = function () {
  move_left();
};
document.querySelector("#button_right").onclick = function () {
  move_right();
};

document.querySelector("#button_r").onclick = oanimation.reverse;
document.querySelector("#button_s").onclick = oanimation.pause;
document.querySelector("#button_z").onclick = function () {
  if (soundon == 1) {
    soundon = 0;
    Howler.volume = 0;
  } else {
    soundon = 1;
    Howler.volume = 0;
  }
};

document.querySelector("#button_l").onclick = function () {
  var animation2 = anime({
    targets: "#whole",
    scale: mer,
    duration: 800,
    easing: "easeInElastic(2, .9)"
  });
  if (mer == 0.75) mer = 1;
  else mer = 0.75;
};

// animate elements (icons and bubbles)

var stred_x = polomer - posun_x;
var stred_y = polomer + posun_y;
var obzor_koef = 0.715;

let icons = [...document.querySelectorAll(".icon")];
var animation_icon = [];

icons.forEach((el, ind) => {
  // set correct size and position
  var ow = el.viewBox.baseVal.width;
  var oh = el.viewBox.baseVal.height;
  var pos = el.getAttribute("pos");
  var corr = el.getAttribute("corr");
  var rot = el.getAttribute("rot");
  var nw = Math.round(ow * resize_factor);
  var nh = Math.round(oh * resize_factor);
  var pos_x = -Math.round(polomer * obzor_koef * corr * Math.sin(degrad(pos)));
  var pos_y = -Math.round(polomer * obzor_koef * corr * Math.cos(degrad(pos)));
  console.log(
    "ICON " +
      ind +
      ", width: " +
      ow +
      ", height: " +
      oh +
      ", uhel: " +
      pos +
      ", cor: " +
      corr +
      ", pos_x: " +
      pos_x +
      ", pos_y:" +
      pos_y
  );
  el.parentElement.style.position = "absolute";
  el.parentElement.style.width = nw + "px";
  el.parentElement.style.height = nh + "px";
  el.parentElement.style.left = stred_x + pos_x - Math.round(nw / 2) + "px";
  el.parentElement.style.top = stred_y + pos_y - Math.round(nh / 2) + "px";
  // animate if possible
  if (rot == 1) {
    animation_icon[ind] = anime({
      targets: el,
      rotate: [-8, 8],
      duration: 6000,
      loop: true,
      direction: "alternate",
      easing: "easeInOutSine"
    });
  }
});

let bubbles = [...document.querySelectorAll(".icon circle")];
var animation_bubble = [];

bubbles.forEach((el, ind) => {
  animation_bubble[ind] = anime({
    targets: el,
    duration: Math.floor(1500 + Math.random() * 3000),
    scale: 0.4 + Math.random() * 0.4,
    direction: "alternate",
    loop: true,
    easing: "easeInOutSine"
  });
});

var animation_progbubble = [];

// show all links for program items (gray buildings)
Object.keys(progItems).forEach(function (key, index) {
  var id = key;
  var rot = progItems[key].rot;
  var corr = progItems[key].corr;
  var file = progItems[key].file;
  var img = document.createElement("img");
  var a = document.createElement("a");
  img.src = "./src/assets/" + file;
  img.className = "aicon";
  img.style.width = "100%";
  img.style.transform = "rotate(" + -rot + "deg)";
  img.setAttribute("typ", id);
  a.appendChild(img);
  a.setAttribute("href", "#?" + id);
  var nw = Math.round(0.8 * resize_factor);
  var nh = Math.round(0.8 * resize_factor);
  var pos_x = -Math.round(
    polomer * obzor_koef * 1.02 * corr * Math.sin(degrad(rot))
  );
  var pos_y = -Math.round(
    polomer * obzor_koef * 1.02 * corr * Math.cos(degrad(rot))
  );
  console.log(
    id +
      " -> rot:" +
      rot +
      ", corr:" +
      corr +
      ", pos_x:" +
      pos_x +
      ", pos_y:" +
      pos_y
  );
  a.style.position = "absolute";
  a.style.width = nw + "px";
  a.style.height = nh + "px";
  a.setAttribute("typ", id);
  a.style.left = stred_x + pos_x - Math.round(nw / 2) + "px";
  a.style.top = stred_y + pos_y - Math.round(nh / 2) + "px";
  document.getElementById("whole").appendChild(a);
  animation_progbubble[id] = anime({
    targets: a,
    duration: 1200,
    scale: 0.75,
    direction: "alternate",
    loop: true,
    easing: "easeInOutSine"
  });
});

// resize buresh car
var babish = document.getElementById("bureshkara");
var babish_orig_size = 9;
var babish_size = Math.floor(babish_orig_size * resize_factor);
babish.style.position = "absolute";
babish.style.width = babish_size + "px";
babish.style.height = babish_size + "px";
babish.style.left = -Math.round(babish_size / 2) + "px";
babish.style.top = -Math.round(babish_size / 2) + "px";

// resize and position biker
var biker = document.getElementById("biker");
var biker_orig_size = 3;
var biker_size = Math.floor(biker_orig_size * resize_factor);
biker.style.position = "absolute";
biker.style.width = biker_size + "px";
biker.style.height = biker_size + "px";
biker.style.left = stred_x - Math.round(biker_size / 2) + "px";
biker.style.top =
  stred_y - Math.round(polomer * 0.676) - Math.round(biker_size / 2) + "px";

// keyboard events

var infowindow_opened = false;
var introwindow_opened = true;

// Give the document focus
window.focus();

// Remove focus from any focused element
if (document.activeElement) {
  document.activeElement.blur();
}

document.onkeydown = checkKey;

function checkKey(e) {
  e = e || window.event;
  if (e.keyCode == "38") {
  } else if (e.keyCode == "40") {
  } else if (e.keyCode == "37") {
    move_left();
  } else if (e.keyCode == "39") {
    move_right();
  } else if (e.keyCode == "27") {
    if (infowindow_opened) {
      infowindow_opened = false;
      var infoa = anime({
        targets: ".info",
        translateY: height,
        scale: 0.2,
        easing: "easeInOutSine",
        duration: 400
      });
    }
    if (introwindow_opened) {
      introwindow_opened = false;
      var infoa = anime({
        targets: ".intro",
        translateY: -height,
        scale: 0.2,
        easing: "easeInOutSine",
        duration: 800
      });
    }
  }
}

// load data

var jsonURL = "./src/assets/ci2022_out.json";
var jsonProgramURL = "./src/assets/program.json";
var jsonData = [];
var jsonProgramData = [];

function LoadJSON(url) {
  return new Promise(function (resolve, reject) {
    var req = new XMLHttpRequest();
    req.open("GET", url, true);
    req.onreadystatechange = function (evt) {
      if (req.readyState == 4) {
        if (req.status == 200) {
          try {
            var json = JSON.parse(req.responseText);
            resolve(json);
          } catch (ex) {
            reject(ex);
          }
        } else {
          reject(req.status);
        }
      }
    };
    req.send(null);
  });
}

function getData(typ) {
  var outdata = [];
  var outtext = "";
  console.log("Loading typ:" + typ);
  if (typ == "babis") {
    outtext = "<h2 class='nadpis'>Andrej Babiš</h2>";
    jsonProgramData.forEach((item) => {
      if (item.sekce == typ) outtext += item.text;
    });
  } else if (
    typ == "DET" ||
    typ == "SOC" ||
    typ == "SKO" ||
    typ == "ZP" ||
    typ == "ZDR" ||
    typ == "FIN"
  ) {
    outtext +=
      "<h2 class='nadpis'><img src='./src/assets/" +
      typ +
      "_opt_svgo.svg' align='absmiddle' alt='" +
      sekce[typ] +
      "' style='height:1em; filter: invert(100%);' />&nbsp;" +
      sekce[typ] +
      "</h2>";
    jsonData.forEach((item) => {
      if (
        (typ == "DET" && item.DET == "x") ||
        (typ == "SOC" && item.SOC == "x") ||
        (typ == "SKO" && item.SKO == "x") ||
        (typ == "ZP" && item.ZP == "x") ||
        (typ == "ZDR" && item.ZDR == "x") ||
        (typ == "FIN" && item.FIN == "x")
      ) {
        outdata.push(item);
        //console.log(item);
        var nadpis = "";
        var popis = "";
        var link = "";
        if (item.NADPIS === undefined) {
          nadpis = item.POPIS;
        } else {
          nadpis = item.NADPIS;
          popis = "<p>" + item.POPIS + "</p>";
        }
        if (item.WEB !== undefined) {
          link = "<a href='" + item.WEB + "' target='_blank'>link</a>";
        }
        outtext +=
          "<div class='gr'><div class='gi'><img src='https://picsum.photos/seed/" +
          Math.round(Math.random() * 99999) +
          "/300' style='border-radius: 50%; width:100%; min-width:100px;' alt='' /></div><div class='gi'><h4 class='nm'>" +
          nadpis +
          "</h4>" +
          popis +
          item.GARANT +
          " (" +
          item.KRAJ +
          ")</div><div class='gi'>" +
          link +
          "</div></div>";
      }
    });
  } else {
    outtext =
      "<h2 class='nadpis'><img src='./src/assets/" +
      progItems[typ].file +
      "' align='absmiddle' alt='" +
      progItems[typ].title +
      "' style='height:1em;' />&nbsp;" +
      progItems[typ].title +
      "</h2>";
    jsonProgramData.forEach((item) => {
      if (item.sekce == typ) outtext += item.text;
    });
  }
  return outtext;
}

LoadJSON(jsonProgramURL).then(
  function (data) {
    jsonProgramData = data;
    //console.log(data);
    console.log(
      "External program data " +
        jsonProgramURL +
        " loaded. " +
        data.length +
        " items"
    );
  },
  function (error) {
    console.log(error);
  }
);

LoadJSON(jsonURL).then(
  function (data) {
    jsonData = data;
    //console.log(data);
    console.log(
      "External data " + jsonURL + " loaded. " + data.length + " items"
    );
  },
  function (error) {
    console.log(error);
  }
);

// infowindow and click events

let aicons = [...document.querySelectorAll(".aicon")];

aicons.forEach((el, ind) => {
  // onclick event is opening info div
  el.onclick = function () {
    var typ = el.getAttribute("typ");
    var inhtml = getData(typ);
    document.getElementById("infoinner").innerHTML = inhtml;
    document.getElementById("infoinner").scrollTop = 0;
    infowindow_opened = true;
    var infoa = anime({
      targets: ".info",
      translateY: 0,
      scale: 1,
      easing: "easeInOutSine",
      duration: 400
    });
  };
});

document.getElementById("close").onclick = function () {
  infowindow_opened = false;
  var infoa = anime({
    targets: ".info",
    translateY: height,
    scale: 0.2,
    easing: "easeInOutSine",
    duration: 400
  });
};

var infoa2 = anime({
  targets: ".info",
  translateY: height,
  scale: 0.2,
  easing: "easeInOutSine",
  duration: 5
});

document.getElementById("intro").onclick = function () {
  introwindow_opened = false;
  var infoa = anime({
    targets: ".intro",
    translateY: -height,
    scale: 0.2,
    easing: "easeInOutSine",
    duration: 800
  });
};

infowindow_opened = false;
document.getElementById("info").style.display = "block";
document.getElementById("screen").style.display = "block";
